<template>
  <Toolbar class="categories">
    <template #start>
      <Skeleton v-if="loadingCategories" width="100px" height="32px" class="button-skeleton" />
      <Skeleton v-if="loadingCategories" width="100px" height="32px" class="button-skeleton" />
      <Skeleton v-if="loadingCategories" width="100px" height="32px" class="button-skeleton" />
      <Button v-for="category in categories" :key="category" :label="category" class="p-button-sm" @click="fetchJokesByCategory(category)" />
    </template>
  </Toolbar>
  <div v-if="loadingJokes">
    <div class="custom-skeleton p-4">
      <div class="flex mb-3">
        <div>
          <Skeleton width="10rem" class="mb-2"></Skeleton>
          <Skeleton width="5rem" class="mb-2"></Skeleton>
          <Skeleton height=".5rem"></Skeleton>
        </div>
      </div>
      <Skeleton width="100%" height="50px"></Skeleton>
    </div>
    <div v-if="loadingJokes" class="custom-skeleton p-4">
      <div class="flex mb-3">
        <div>
          <Skeleton width="10rem" class="mb-2"></Skeleton>
          <Skeleton width="5rem" class="mb-2"></Skeleton>
          <Skeleton height=".5rem"></Skeleton>
        </div>
      </div>
      <Skeleton width="100%" height="50px"></Skeleton>
    </div>
    <div v-if="loadingJokes" class="custom-skeleton p-4">
      <div class="flex mb-3">
        <div>
          <Skeleton width="10rem" class="mb-2"></Skeleton>
          <Skeleton width="5rem" class="mb-2"></Skeleton>
          <Skeleton height=".5rem"></Skeleton>
        </div>
      </div>
      <Skeleton width="100%" height="50px"></Skeleton>
    </div>
  </div>

  <div v-if="!loadingJokes">
    <Card v-for="joke in jokes" :key="joke.id">
      <template #title>
        <div class="field-checkbox">
          <Checkbox v-model="selectedJokes" :value="joke.id" :input-id="joke.id" />
          <label :for="joke.id">Download joke</label>
        </div>
      </template>
      <template #content>
        {{ joke.value }}
      </template>
    </Card>
  </div>
  <div v-if="!loadingJokes && selectedJokes.length" class="generate-button">
    <Button label="Generate & Download PDF" :disabled="preparingDownload" @click="generatePDF()" />
  </div>
</template>

<script setup lang="ts">
import { useJokesStore } from "@/stores/jokes";
import { computed, onMounted, ref } from "vue";
import { useRouter } from "vue-router";
const router = useRouter();

const jokesStore = useJokesStore();

const categories = computed(() => jokesStore.categories);
const loadingCategories = computed(() => jokesStore.loadingCategories);
const jokes = computed(() => jokesStore.jokes);
const loadingJokes = computed(() => jokesStore.loadingJokes);
const preparingDownload = computed(() => jokesStore.preparingDownload);

const selectedJokes = ref([]);

const fetchJokesByCategory = (category?: string) => {
  jokesStore.fetchJokes(3, category);
};

const generatePDF = async () => {
  const download = await jokesStore.generateDownload(selectedJokes.value);
  if (download) {
    router.push(`/download/${download.id}`);
  }
};

onMounted(() => {
  jokesStore.fetchCategories();
  jokesStore.fetchJokes(3);
});
</script>

<style>
.button-skeleton {
  margin-right: 16px;
}
.field-checkbox {
  font-size: 12px;
  display: block;
}
.custom-skeleton {
  border: 1px solid var(--surface-border);
  border-radius: 4px;
}
.generate-button {
  margin: 1em;
}
</style>
